﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using tediadaq01_dotnet;

namespace ExampleAnalog
{
  class Program
  {
    static void Main(string[] args)
    {
      UInt32 Handle = 0;
      StringBuilder Sb = new StringBuilder("EXAM_ANALOG", 30);
      if (!ResolveError(TediaDaq01.Td_Init_Driver(ref Handle, Sb)))
        return;

      Console.WriteLine("Opened device: \"" + Sb + "\"");


      if (!ResolveError(TediaDaq01.Td_Config_Acquisition(Handle, 0, 0, 0, 3))) // input ch 0, gain 0, index 0, channels count 3
          return;
      if (!ResolveError(TediaDaq01.Td_Config_Acquisition(Handle, 6, 4, 1, 3))) // input ch 6, gain 4, index 1, channels count 3
          return;
      if (!ResolveError(TediaDaq01.Td_Config_Acquisition(Handle, 7, 5, 2, 3))) // input ch 7, gain 5, index 2, channels count 3
          return;


      if (!ResolveError(TediaDaq01.Td_Start_Acquisition(Handle, 1)))
        return;

      UInt32[] Data = new UInt32[20];
      if (!ResolveError(TediaDaq01.Td_Get_SingleAcquisition(Handle, Data, 20)))
          return;

      if (!ResolveError(TediaDaq01.Td_Stop_Acquisition(Handle)))
          return;

      System.Console.WriteLine("AIN [0]: " + Data[0].ToString());
      System.Console.WriteLine("AIN [6]: " + Data[1].ToString());
      System.Console.WriteLine("AIN [7]: " + Data[2].ToString());


      if (!ResolveError(TediaDaq01.Td_Close_Driver(Handle)))
        return;
        Console.WriteLine("OK");
    }

    static bool ResolveError(UInt32 Err)
    {
      if (Err != 0)
      {
        StringBuilder StrError = new StringBuilder(500);
        StringBuilder StrFunction = new StringBuilder(500);
        TediaDaq01.Td_Get_ErrorMessage(Err, StrFunction, StrError);
        System.Console.WriteLine("Error: \"" + StrError + "\" in function: " + StrFunction);
        return false;
      }
      return true;
    }
  }
} // ExampleAnalog
